#!/usr/local/bin/perl

require "globalVariables";
require "Rweb.pm";

$identifier = $$;
&createTempFiles;  	# For data, output, ...
$time = time();

# Get the forms data
&ReadParse;
$Rcommands = $in{'comments'};

# Setting up the returned web page
print "Content-type: text/html\n\n"; 

print("<BODY> \n");
print "<title>Results from Rweb</title><h1>Results from Rweb</h1><hr>";

#====================== Bringing in an External Data Set  ==============
if ($in{'Data'}){
  $in{'dataname'} = "URLdata";
  $dataInput = bringInData (\%in);
  if ($dataInput){
    &inputStuff($dataInput);
  }
  else {
    exit();
  }
}
#====================== End of External Data Set Input ==============

# Maintain a log file to keep track of use
if ( $LOGFILE ) {
  open (logFile, ">> log.Rweb");  
  print logFile "Host:$ENV{'REMOTE_HOST'}%Address:$ENV{'REMOTE_ADDR'}%Browser:$ENV{'HTTP_USER_AGENT'}%Time:$time\n";
  close(logFile);
}

# Checking for security problems
&Security;

################################################################
################################################################
# writing the R commands out to a file  
open(OUTPUTFILE, "> $FCode");
print OUTPUTFILE ("postscript(file= \"$FOutputPS\", height = 8, width = 8)\n");
print OUTPUTFILE ("$input{'code'} \n"); # code to load and setup data


# This writes out the commands from the text field
print OUTPUTFILE ("$Rcommands");
print OUTPUTFILE ("\n");
close(OUTPUTFILE);


# Now run R in batch mode using the saved commands as the input.
# Output goes into another file that is then read back in and displayed,
# it would be better to do this without the output file but I can't get
# the output to sinc up with the rest of the code ...

&runR;

&printResults;

# Process the postscript file, create gif files and write the necessary code
# into a new Rgif* html file ... this all happens in the $TMPDIR directory
&processPostscript;

&RwebExit;
