#!/usr/local/bin/perl -w
require "globalVariables";
require "Rweb.pm";

$identifier = $$;
&createTempFiles;  	# For data, output, ...
$time = time();

# Get the forms data
&ReadParse;
$Rcommands = $in{'comments'};

#====================== Bringing in an External Data Set  ==============
if ($in{'Data'}){
  $in{'dataname'} = "URLdata";
  $dataInput = bringInData (\%in);
  &inputStuff($dataInput);
}
#====================== End of External Data Set Input ==============

# Maintain a log file to keep track of use
if ( $LOGFILE ) {
  open (logFile, ">> log.RwebJavaScript");  
  print logFile "Host:$ENV{'REMOTE_HOST'}%Address:$ENV{'REMOTE_ADDR'}%Browser:$ENV{'HTTP_USER_AGENT'}%Time:$time\n";
  close(logFile);
}

# Checking for security problems
&Security;

# Setting up the returned web page
print "Content-type: text/html\n\n"; 

print("<BODY> \n");
################################################################
################################################################
# writing the R commands out to a file  
open(OUTPUTFILE, "> /tmp/Rcode.$identifier.txt");
print OUTPUTFILE ("postscript(file= \"/tmp/Rout.$identifier.ps\", height = 5, width = 6)\n");
print OUTPUTFILE ("$input{'code'} \n"); # code to load and setup data


$sinkFile = "/tmp/Rout.$identifier.sink";
print OUTPUTFILE "sink(\"$sinkFile\") \n";

# This writes out the commands from the text field
print OUTPUTFILE ("$Rcommands ");
print OUTPUTFILE ("\n");
close(OUTPUTFILE);


# Now run R in batch mode using the saved commands as the input.
# Output goes into the sink file
&runR;

#======================== Rebuilding the Code window ===================

print << "ending_print_tag";

<HEAD>
    <TITLE>Rweb Code Page</TITLE>
</HEAD>
<BODY>

  <FORM METHOD="POST" ACTION="http://$SERVER/$CGIDIR/RwebJavaScript.cgi">
    <TEXTAREA NAME="comments" ROWS=15 COLS=60>$Rcommands</TEXTAREA> <P>
    <inPUT TYPE="submit" VALUE="Submit">
    <BR>
    Dataset URL
    <INPUT TYPE="TEXT" NAME="Data" SIZE=50 Value="$dataURL">
    </FORM>
    </P>

ending_print_tag
#==================== End of rebuilding the Code Window  =================
#==================== Build the Debug  Window  =================
print << "ending_print_tag";

<script language="JavaScript">

<!-- hide the following from non JavaScript Browsers
  debugWin= open("", "debugWindow", 
    "width=600,height=150,status=no,scrollbars=yes,resizable=yes");

  // open document for further output
  debugWin.document.open();
  
  // create document
  debugWin.document.write("<html><head><title>Rweb Debug Window");
  debugWin.document.write('</title></head><body>');
  debugWin.document.write("<PRE>");

ending_print_tag


open(ResultFile, "/tmp/Rout.$identifier.txt");
    while (<ResultFile>){
	chomp();
	s/\r//g;
	s/'/`/g;  #' This comment is just so my emacs will stop formating everything as a string
	print ("debugWin.document.writeln(\'$_\') \n");
	}
close(ResultFile);


print << "ending_print_tag";

  debugWin.document.write("</PRE>");
  debugWin.document.write("</body></html>");

  // close the document - (not the window!)
  debugWin.document.close();  


// End of comment hiding JavaScript code  -->

</script>

ending_print_tag
#==================== End of building the Debug  Window  =================

## convert the postscript images to gif format
&ps2gif;

### =====================Writing out the gif files ===========================
# what gif files do we have?
@gifFiles = glob("Rout$identifier*.gif");

# Check to see if there are any images
if (defined($gifFiles[0])){


## ==== The javascript functions to put images in popup window ========
print << "ending_print_tag";

<script language="JavaScript">

<!-- hide the following from non JavaScript Browsers
//  graphWin= open("", "displayWindow", 
//    "width=500,height=550,status=no,toolbar=yes,menubar=no,resizable=yes");
  graphWin= open("", "displayWindow", 
    "width=450,height=350,scrollbars=yes,menubar=yes,resizable=yes");

  // open document for further output
  graphWin.document.open();
  
  // create document
  graphWin.document.write("<html><head><title>Rweb Images");
  graphWin.document.write('</title></head><body bgcolor="#ffffff">');
//  graphWin.document.write("<center><font size=+3>");
//  graphWin.document.write("Images from Rweb");
//  graphWin.document.write("</font></center>");
ending_print_tag



    foreach $name (@gifFiles){
	$printCommand ="<IMG  SRC=\"http://$SERVER/$CGIDIR/nph-imageDump.pl?/tmp/$name\">";
	print ("graphWin.document.write(\' $printCommand \') \n");
	print ("graphWin.document.write('<HR>') \n");
    }

print << "ending_print_tag";

  graphWin.document.write("</body></html>");

  // close the document - (not the window!)
  graphWin.document.close();  


// End of comment hiding JavaScript code  -->

</script>

ending_print_tag
}
##==========================End of JavaScript ======================
##==========================End of Gif Files ======================

### =====================Writing out the Sink files ===========================


## Create popup window and write temp file there

## ==== The javascript functions to put Text output into a popup window ========
print << "ending_print_tag";

<script language="JavaScript">

<!-- hide the following from non JavaScript Browsers
//  textWin= open("", "textWindow", 
//    "width=400,height=400,resizable=yes");
  textWin= open("", "textWindow", 
    "width=600,height=250,menubar=yes,scrollbars=yes,resizable=yes");

  // open document for further output
  textWin.document.open();
  
  // create document
  textWin.document.write("<html><head><title> Rweb Analysis Output");
  textWin.document.write("</title></head><body>");
//  textWin.document.write("<center><font size=+3>");
//  textWin.document.write("Analysis from Rweb");
//  textWin.document.write("</font></center>");
  textWin.document.write("<PRE>");
ending_print_tag



# open sinkFile and print the results to the text window document
open(textFile, $sinkFile);

while (<textFile>){
	chomp();
	s/\r//g;
	s/'/`/g; #' This comment is just so my emacs will stop formating everything as a string
    print("textWin.document.writeln(\'$_\') \n");
}

close(textFile);


print << "ending_print_tag";

  textWin.document.write("</PRE>");

  textWin.document.write("</body></html>");

  // close the document - (not the window!)
  textWin.document.close();  


// End of comment hiding JavaScript code  -->

</script>

ending_print_tag

##==========================End of JavaScript ======================
    print "</BODY> </HTML>";


&RwebExit;
