#!/usr/local/bin/perl -w

require "globalVariables";
require Rweb;

$identifier = $$;
&createTempFiles;  	# For data, output, ...

print "Content-type: text/html\n\n";
print "<title>Dataset and Analysis</title>\n";
print "<IMG SRC=\"http://$SERVER/$RWEBDIR/RwebLogo.GIF\" ALT=\"Great Rweb Logo\">";
print "\n <BR> \n You are using the Rweb server at $SERVER \n \n";

# Read in the forms data ... %in will be indexed by "dataname" and "analysis"
&ReadParse;

#====================== Bringing in the Data Set  ==============
$dataInput = bringInData (\%in);

#====================== Process the Input file ==============
&inputStuff ($dataInput);
$names = $input{'variables'};   # This is the only reason we have run the last 2 lines

################################################################
$dataname = $in{'dataname'};
$analysis = $in{'analysis'};

# If a description file exists, read it in and put it on the ouput page
if (-e "DataSets/$dataname.desc"){
    open(descFile, "$RWEBDATA/$dataname.desc");
    @fileContents = <descFile>;
    close(descFile);

# If the first element is a "<" assume it is html formatted
# otherwise print it out as preformatted text
    if ($fileContents[0] =~ /^</){
	foreach $line (@fileContents){
	    print $line;
	}
    }
    else{
	print "<PRE>";
	foreach $line (@fileContents){
	    print $line;
	}
	print "</PRE>";
    }
}

$setupFile = "AnalysisModules/setup$analysis";

if ( -f $setupFile ){
	do $setupFile;
}
else{ 
	print("<PRE>");
	print "\n The analysis $analysis has not been implemented \n"; 
	print ("</PRE>")}

&RwebExit;





