#!/usr/local/bin/perl -w

require "../globalVariables";
require "../Rweb.pm";

$identifier = $$;
&createTempFiles;  	# For data, output, ...

&ReadParse;
$time = time();

if ( $LOGFILE ) {
open (logFile, ">> log.Probability");
print logFile "Host:$ENV{'REMOTE_HOST'}%Address:$ENV{'REMOTE_ADDR'}%Browser:$ENV{'HTTP_USER_AGENT'}%Time:$time\n";
close(logFile);
}
################################################################

## open up the file for storing the R code
open (RoutFile, "> $FCode");

print "Content-type: text/html\n\n";

print "<H1> Probability Results </H1> \n";


####### check for which probabilities they want #########

if( $in{'normalk'} =~ /\d/){
    print RoutFile ("# CUMULATIVE NORMAL DISTRIBUTION \n");
    print RoutFile ("pnorm($in{'normalk'}, $in{'normalmu'}, $in{'normalsigma'}) \n");
 }
if( $in{'tk'} =~ /\d/){
    print RoutFile ("# CUMULATIVE T DISTRIBUTION \n");
    print RoutFile ("pt($in{'tk'}, $in{'tdf'}) \n");
 }
if( $in{'binomialcdfk'} =~ /\d/){
    print RoutFile ("# CUMULATIVE BINOMIAL DISTRIBUTION \n");
    print RoutFile ("pbinom($in{'binomialcdfk'}, $in{'binomialcdfn'}, $in{'binomialcdfp'}) \n");
 }
if( $in{'binomialpdfk'} =~ /\d/){
    print RoutFile ("# CUMULATIVE BINOMIAL DISTRIBUTION \n");
    print RoutFile ("dbinom($in{'binomialpdfk'}, $in{'binomialpdfn'}, $in{'binomialpdfp'}) \n");
 }
if( $in{'chisqk'} =~ /\d/){
    print RoutFile ("# UPPER TAIL PROBABILITIES FOR CHI SQUARE DISTRIBUTION \n");
    print RoutFile ("1-pchisq($in{'chisqk'}, $in{'chisqdf'}) \n");
 }

close(RoutFile);
###########################################################################
# Now run R in batch mode using the saved commands as the input.
# Output goes into another file that is then read back in and displayed,
# it would be better to do this without the output file but I can't get
# the output to sinc up with the rest of the code ...

&runR;

&printResults;

&RwebExit;



















